/*
Inbox

Inbox API can be used for low level integration and enables direct communication with you contact base.   In most cases you will use our interaction templates for communication, but our api also allows you to send message directly.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package inboxapi

import (
	"encoding/json"
)

// checks if the ListContactActivities200Response type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ListContactActivities200Response{}

// ListContactActivities200Response struct for ListContactActivities200Response
type ListContactActivities200Response struct {
	Results []Activity `json:"results,omitempty"`
	Total *int32 `json:"total,omitempty"`
}

// NewListContactActivities200Response instantiates a new ListContactActivities200Response object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewListContactActivities200Response() *ListContactActivities200Response {
	this := ListContactActivities200Response{}
	return &this
}

// NewListContactActivities200ResponseWithDefaults instantiates a new ListContactActivities200Response object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewListContactActivities200ResponseWithDefaults() *ListContactActivities200Response {
	this := ListContactActivities200Response{}
	return &this
}

// GetResults returns the Results field value if set, zero value otherwise.
func (o *ListContactActivities200Response) GetResults() []Activity {
	if o == nil || IsNil(o.Results) {
		var ret []Activity
		return ret
	}
	return o.Results
}

// GetResultsOk returns a tuple with the Results field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ListContactActivities200Response) GetResultsOk() ([]Activity, bool) {
	if o == nil || IsNil(o.Results) {
		return nil, false
	}
	return o.Results, true
}

// HasResults returns a boolean if a field has been set.
func (o *ListContactActivities200Response) HasResults() bool {
	if o != nil && !IsNil(o.Results) {
		return true
	}

	return false
}

// SetResults gets a reference to the given []Activity and assigns it to the Results field.
func (o *ListContactActivities200Response) SetResults(v []Activity) {
	o.Results = v
}

// GetTotal returns the Total field value if set, zero value otherwise.
func (o *ListContactActivities200Response) GetTotal() int32 {
	if o == nil || IsNil(o.Total) {
		var ret int32
		return ret
	}
	return *o.Total
}

// GetTotalOk returns a tuple with the Total field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ListContactActivities200Response) GetTotalOk() (*int32, bool) {
	if o == nil || IsNil(o.Total) {
		return nil, false
	}
	return o.Total, true
}

// HasTotal returns a boolean if a field has been set.
func (o *ListContactActivities200Response) HasTotal() bool {
	if o != nil && !IsNil(o.Total) {
		return true
	}

	return false
}

// SetTotal gets a reference to the given int32 and assigns it to the Total field.
func (o *ListContactActivities200Response) SetTotal(v int32) {
	o.Total = &v
}

func (o ListContactActivities200Response) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ListContactActivities200Response) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Results) {
		toSerialize["results"] = o.Results
	}
	if !IsNil(o.Total) {
		toSerialize["total"] = o.Total
	}
	return toSerialize, nil
}

type NullableListContactActivities200Response struct {
	value *ListContactActivities200Response
	isSet bool
}

func (v NullableListContactActivities200Response) Get() *ListContactActivities200Response {
	return v.value
}

func (v *NullableListContactActivities200Response) Set(val *ListContactActivities200Response) {
	v.value = val
	v.isSet = true
}

func (v NullableListContactActivities200Response) IsSet() bool {
	return v.isSet
}

func (v *NullableListContactActivities200Response) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableListContactActivities200Response(val *ListContactActivities200Response) *NullableListContactActivities200Response {
	return &NullableListContactActivities200Response{value: val, isSet: true}
}

func (v NullableListContactActivities200Response) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableListContactActivities200Response) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


